"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchRedeemerFromSeeds = exports.fetchRedeemerFromSeeds = exports.findRedeemerPda = exports.getRedeemerSize = exports.getRedeemerGpaBuilder = exports.safeFetchAllRedeemer = exports.fetchAllRedeemer = exports.safeFetchRedeemer = exports.fetchRedeemer = exports.deserializeRedeemer = exports.getRedeemerAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getRedeemerAccountDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        ['authority', (0, serializers_1.publicKey)()],
        ['validator', (0, serializers_1.publicKey)()],
    ], { description: 'RedeemerAccountData' }), (value) => ({ ...value, key: types_1.Key.Redeemer }));
}
exports.getRedeemerAccountDataSerializer = getRedeemerAccountDataSerializer;
function deserializeRedeemer(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getRedeemerAccountDataSerializer());
}
exports.deserializeRedeemer = deserializeRedeemer;
async function fetchRedeemer(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Redeemer');
    return deserializeRedeemer(maybeAccount);
}
exports.fetchRedeemer = fetchRedeemer;
async function safeFetchRedeemer(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeRedeemer(maybeAccount) : null;
}
exports.safeFetchRedeemer = safeFetchRedeemer;
async function fetchAllRedeemer(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Redeemer');
        return deserializeRedeemer(maybeAccount);
    });
}
exports.fetchAllRedeemer = fetchAllRedeemer;
async function safeFetchAllRedeemer(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeRedeemer(maybeAccount));
}
exports.safeFetchAllRedeemer = safeFetchAllRedeemer;
function getRedeemerGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        padding: [2, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        authority: [8, (0, serializers_1.publicKey)()],
        validator: [40, (0, serializers_1.publicKey)()],
    })
        .deserializeUsing((account) => deserializeRedeemer(account))
        .whereField('key', types_1.Key.Redeemer);
}
exports.getRedeemerGpaBuilder = getRedeemerGpaBuilder;
function getRedeemerSize() {
    return 72;
}
exports.getRedeemerSize = getRedeemerSize;
function findRedeemerPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('redeemer'),
        (0, serializers_1.publicKey)().serialize(seeds.vault),
    ]);
}
exports.findRedeemerPda = findRedeemerPda;
async function fetchRedeemerFromSeeds(context, seeds, options) {
    return fetchRedeemer(context, findRedeemerPda(context, seeds), options);
}
exports.fetchRedeemerFromSeeds = fetchRedeemerFromSeeds;
async function safeFetchRedeemerFromSeeds(context, seeds, options) {
    return safeFetchRedeemer(context, findRedeemerPda(context, seeds), options);
}
exports.safeFetchRedeemerFromSeeds = safeFetchRedeemerFromSeeds;
//# sourceMappingURL=redeemer.js.map