"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchVaultFromSeeds = exports.fetchVaultFromSeeds = exports.findVaultPda = exports.getVaultSize = exports.getVaultGpaBuilder = exports.safeFetchAllVault = exports.fetchAllVault = exports.safeFetchVault = exports.fetchVault = exports.deserializeVault = exports.getVaultAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getVaultAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['redeemer', (0, types_1.getRedeemerTypeSerializer)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 5 })],
        ['base', (0, serializers_1.publicKey)()],
        ['authority', (0, serializers_1.publicKey)()],
        ['creator', (0, serializers_1.publicKey)()],
        ['tokenList', (0, serializers_1.array)((0, types_1.getTokenEntrySerializer)(), { size: 'remainder' })],
    ], { description: 'VaultAccountData' });
}
exports.getVaultAccountDataSerializer = getVaultAccountDataSerializer;
function deserializeVault(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getVaultAccountDataSerializer());
}
exports.deserializeVault = deserializeVault;
async function fetchVault(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Vault');
    return deserializeVault(maybeAccount);
}
exports.fetchVault = fetchVault;
async function safeFetchVault(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeVault(maybeAccount) : null;
}
exports.safeFetchVault = safeFetchVault;
async function fetchAllVault(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Vault');
        return deserializeVault(maybeAccount);
    });
}
exports.fetchAllVault = fetchAllVault;
async function safeFetchAllVault(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeVault(maybeAccount));
}
exports.safeFetchAllVault = safeFetchAllVault;
function getVaultGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        redeemer: [2, (0, types_1.getRedeemerTypeSerializer)()],
        padding: [3, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 5 })],
        base: [8, (0, serializers_1.publicKey)()],
        authority: [40, (0, serializers_1.publicKey)()],
        creator: [72, (0, serializers_1.publicKey)()],
        tokenList: [104, (0, serializers_1.array)((0, types_1.getTokenEntrySerializer)(), { size: 'remainder' })],
    })
        .deserializeUsing((account) => deserializeVault(account));
}
exports.getVaultGpaBuilder = getVaultGpaBuilder;
function getVaultSize() {
    return 104;
}
exports.getVaultSize = getVaultSize;
function findVaultPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('vault'),
        (0, serializers_1.publicKey)().serialize(seeds.creator),
        (0, serializers_1.publicKey)().serialize(seeds.base),
    ]);
}
exports.findVaultPda = findVaultPda;
async function fetchVaultFromSeeds(context, seeds, options) {
    return fetchVault(context, findVaultPda(context, seeds), options);
}
exports.fetchVaultFromSeeds = fetchVaultFromSeeds;
async function safeFetchVaultFromSeeds(context, seeds, options) {
    return safeFetchVault(context, findVaultPda(context, seeds), options);
}
exports.safeFetchVaultFromSeeds = safeFetchVaultFromSeeds;
//# sourceMappingURL=vault.js.map