"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createVault = exports.getCreateVaultInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getCreateVaultInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([['discriminator', (0, serializers_1.u8)()]], {
        description: 'CreateVaultInstructionData',
    }), (value) => ({ ...value, discriminator: 1 }));
}
exports.getCreateVaultInstructionDataSerializer = getCreateVaultInstructionDataSerializer;
// Instruction.
function createVault(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplVault', 'VAULTGBXz4HaFrg7PcQDWBF3Aj4E1Q1mvWUrAAo64pM');
    // Accounts.
    const resolvedAccounts = {
        vault: {
            index: 0,
            isWritable: true,
            value: input.vault ?? null,
        },
        creator: {
            index: 1,
            isWritable: false,
            value: input.creator ?? null,
        },
        base: { index: 2, isWritable: false, value: input.base ?? null },
        payer: {
            index: 3,
            isWritable: true,
            value: input.payer ?? null,
        },
        systemProgram: {
            index: 4,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
        sysvarInstructions: {
            index: 5,
            isWritable: false,
            value: input.sysvarInstructions ?? null,
        },
    };
    // Default values.
    if (!resolvedAccounts.creator.value) {
        resolvedAccounts.creator.value = context.identity;
    }
    if (!resolvedAccounts.vault.value) {
        resolvedAccounts.vault.value = (0, accounts_1.findVaultPda)(context, {
            creator: (0, shared_1.expectPublicKey)(resolvedAccounts.creator.value),
            base: (0, shared_1.expectPublicKey)(resolvedAccounts.base.value),
        });
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    if (!resolvedAccounts.sysvarInstructions.value) {
        resolvedAccounts.sysvarInstructions.value = (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111');
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getCreateVaultInstructionDataSerializer().serialize({});
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.createVault = createVault;
//# sourceMappingURL=createVault.js.map